copy_db_snapshot¶
Operation¶
copy_db_snapshot
async
¶
copy_db_snapshot(request: CopyDBSnapshotInput | CopyDBSnapshotInputDict, /, *, plugins: list[Plugin] | None = None) -> CopyDBSnapshotOutput
copy_db_snapshot(*, plugins: list[Plugin] | None = None, **kwargs: Unpack[CopyDBSnapshotInputDict]) -> CopyDBSnapshotOutput
Copies the specified DB snapshot. The source DB snapshot must be in the
available state.
You can copy a snapshot from one Amazon Web Services Region to another.
In that case, the Amazon Web Services Region where you call the
CopyDBSnapshot operation is the destination Amazon Web Services Region
for the DB snapshot copy.
This command doesn't apply to RDS Custom.
For more information about copying snapshots, see Copying a DB Snapshot in the Amazon RDS User Guide.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
plugins
|
list[Plugin] | None
|
A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations. |
None
|
Returns:
| Type | Description |
|---|---|
CopyDBSnapshotOutput
|
An instance of |
Input¶
Pass the input fields as keyword arguments, or pass a model or dictionary as the first positional argument. Pass plugins separately as a keyword argument.
Model¶
CopyDBSnapshotInput
dataclass
¶
Bases: _SerdeShape
Attributes¶
copy_option_group
class-attribute
instance-attribute
¶
copy_option_group: bool | None = ...
Specifies whether to copy the DB option group associated with the source DB snapshot to the target Amazon Web Services account or Amazon Web Services Region and associate it with the target DB snapshot.
copy_tags
class-attribute
instance-attribute
¶
copy_tags: bool | None = ...
Specifies whether to copy all tags from the source DB snapshot to the target DB snapshot. By default, tags aren't copied.
kms_key_id
class-attribute
instance-attribute
¶
kms_key_id: str | None = ...
The Amazon Web Services KMS key identifier for an encrypted DB snapshot. The Amazon Web Services KMS key identifier is the key ARN, key ID, alias ARN, or alias name for the KMS key.
If you copy an encrypted DB snapshot from your Amazon Web Services account, you can specify a value for this parameter to encrypt the copy with a new KMS key. If you don't specify a value for this parameter, then the copy of the DB snapshot is encrypted with the same Amazon Web Services KMS key as the source DB snapshot.
If you copy an encrypted DB snapshot that is shared from another Amazon Web Services account, then you must specify a value for this parameter.
If you specify this parameter when you copy an unencrypted snapshot, the copy is encrypted.
If you copy an encrypted snapshot to a different Amazon Web Services Region, then you must specify an Amazon Web Services KMS key identifier for the destination Amazon Web Services Region. KMS keys are specific to the Amazon Web Services Region that they are created in, and you can't use KMS keys from one Amazon Web Services Region in another Amazon Web Services Region.
option_group_name
class-attribute
instance-attribute
¶
option_group_name: str | None = ...
The name of an option group to associate with the copy of the snapshot.
Specify this option if you are copying a snapshot from one Amazon Web Services Region to another, and your DB instance uses a nondefault option group. If your source DB instance uses Transparent Data Encryption for Oracle or Microsoft SQL Server, you must specify this option when copying across Amazon Web Services Regions. For more information, see Option group considerations in the Amazon RDS User Guide.
pre_signed_url
class-attribute
instance-attribute
¶
pre_signed_url: str | None = ...
When you are copying a snapshot from one Amazon Web Services GovCloud
(US) Region to another, the URL that contains a Signature Version 4
signed request for the CopyDBSnapshot API operation in the source
Amazon Web Services Region that contains the source DB snapshot to copy.
This setting applies only to Amazon Web Services GovCloud (US) Regions. It's ignored in other Amazon Web Services Regions.
You must specify this parameter when you copy an encrypted DB snapshot
from another Amazon Web Services Region by using the Amazon RDS API.
Don't specify PreSignedUrl when you are copying an encrypted DB
snapshot in the same Amazon Web Services Region.
The presigned URL must be a valid request for the
CopyDBClusterSnapshot API operation that can run in the source Amazon
Web Services Region that contains the encrypted DB cluster snapshot to
copy. The presigned URL request must contain the following parameter
values:
DestinationRegion- The Amazon Web Services Region that the encrypted DB snapshot is copied to. This Amazon Web Services Region is the same one where theCopyDBSnapshotoperation is called that contains this presigned URL.
For example, if you copy an encrypted DB snapshot from the us-west-2
Amazon Web Services Region to the us-east-1 Amazon Web Services
Region, then you call the CopyDBSnapshot operation in the us-east-1
Amazon Web Services Region and provide a presigned URL that contains a
call to the CopyDBSnapshot operation in the us-west-2 Amazon Web
Services Region. For this example, the DestinationRegion in the
presigned URL must be set to the us-east-1 Amazon Web Services Region.
-
KmsKeyId- The KMS key identifier for the KMS key to use to encrypt the copy of the DB snapshot in the destination Amazon Web Services Region. This is the same identifier for both theCopyDBSnapshotoperation that is called in the destination Amazon Web Services Region, and the operation contained in the presigned URL. -
SourceDBSnapshotIdentifier- The DB snapshot identifier for the encrypted snapshot to be copied. This identifier must be in the Amazon Resource Name (ARN) format for the source Amazon Web Services Region. For example, if you are copying an encrypted DB snapshot from the us-west-2 Amazon Web Services Region, then yourSourceDBSnapshotIdentifierlooks like the following example:arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20161115.
To learn how to generate a Signature Version 4 signed request, see Authenticating Requests: Using Query Parameters (Amazon Web Services Signature Version 4) and Signature Version 4 Signing Process.
Note
If you are using an Amazon Web Services SDK tool or the CLI, you can
specify SourceRegion (or --source-region for the CLI) instead of
specifying PreSignedUrl manually. Specifying SourceRegion
autogenerates a presigned URL that is a valid request for the operation
that can run in the source Amazon Web Services Region.
snapshot_availability_zone
class-attribute
instance-attribute
¶
snapshot_availability_zone: str | None = ...
Specifies the name of the Availability Zone where RDS stores the DB snapshot. This value is valid only for snapshots that RDS stores on a Dedicated Local Zone.
snapshot_target
class-attribute
instance-attribute
¶
snapshot_target: str | None = ...
Configures the location where RDS will store copied snapshots.
Valid Values:
-
local(Dedicated Local Zone) -
outposts(Amazon Web Services Outposts) -
region(Amazon Web Services Region)
source_db_snapshot_identifier
class-attribute
instance-attribute
¶
source_db_snapshot_identifier: str | None = ...
The identifier for the source DB snapshot.
If the source snapshot is in the same Amazon Web Services Region as the
copy, specify a valid DB snapshot identifier. For example, you might
specify rds:mysql-instance1-snapshot-20130805.
If you are copying from a shared manual DB snapshot, this parameter must be the Amazon Resource Name (ARN) of the shared DB snapshot.
If the source snapshot is in a different Amazon Web Services Region than
the copy, specify a valid DB snapshot ARN. You can also specify an ARN
of a snapshot that is in a different account and a different Amazon Web
Services Region. For example, you might specify
arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20130805.
Constraints:
- Must specify a valid source snapshot in the "available" state.
Example: rds:mydb-2012-04-02-00-01
Example:
arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20130805
tag_specifications
class-attribute
instance-attribute
¶
tag_specifications: list[TagSpecification] | None = ...
Tags to assign to the copied option group. By default, the copied option group isn't tagged.
Valid Values:
og- The copied option group.
Constraints:
- Can only be specified when
CopyOptionGroupistrue
tags
class-attribute
instance-attribute
¶
A list of tags.
For more information, see Tagging Amazon RDS resources in the Amazon RDS User Guide or Tagging Amazon Aurora and Amazon RDS resources in the Amazon Aurora User Guide.
target_custom_availability_zone
class-attribute
instance-attribute
¶
target_custom_availability_zone: str | None = ...
The external custom Availability Zone (CAZ) identifier for the target CAZ.
Example: rds-caz-aiqhTgQv.
target_db_snapshot_identifier
class-attribute
instance-attribute
¶
target_db_snapshot_identifier: str | None = ...
The identifier for the copy of the snapshot.
Constraints:
-
Can't be null, empty, or blank
-
Must contain from 1 to 255 letters, numbers, or hyphens
-
First character must be a letter
-
Can't end with a hyphen or contain two consecutive hyphens
Example: my-db-snapshot
Dictionaries¶
CopyDBSnapshotInputDict
¶
Bases: TypedDict
Dictionary form of CopyDBSnapshotInput.
Attributes¶
copy_option_group
instance-attribute
¶
copy_option_group: bool | None
Specifies whether to copy the DB option group associated with the source DB snapshot to the target Amazon Web Services account or Amazon Web Services Region and associate it with the target DB snapshot.
copy_tags
instance-attribute
¶
copy_tags: bool | None
Specifies whether to copy all tags from the source DB snapshot to the target DB snapshot. By default, tags aren't copied.
kms_key_id
instance-attribute
¶
kms_key_id: str | None
The Amazon Web Services KMS key identifier for an encrypted DB snapshot. The Amazon Web Services KMS key identifier is the key ARN, key ID, alias ARN, or alias name for the KMS key.
If you copy an encrypted DB snapshot from your Amazon Web Services account, you can specify a value for this parameter to encrypt the copy with a new KMS key. If you don't specify a value for this parameter, then the copy of the DB snapshot is encrypted with the same Amazon Web Services KMS key as the source DB snapshot.
If you copy an encrypted DB snapshot that is shared from another Amazon Web Services account, then you must specify a value for this parameter.
If you specify this parameter when you copy an unencrypted snapshot, the copy is encrypted.
If you copy an encrypted snapshot to a different Amazon Web Services Region, then you must specify an Amazon Web Services KMS key identifier for the destination Amazon Web Services Region. KMS keys are specific to the Amazon Web Services Region that they are created in, and you can't use KMS keys from one Amazon Web Services Region in another Amazon Web Services Region.
option_group_name
instance-attribute
¶
option_group_name: str | None
The name of an option group to associate with the copy of the snapshot.
Specify this option if you are copying a snapshot from one Amazon Web Services Region to another, and your DB instance uses a nondefault option group. If your source DB instance uses Transparent Data Encryption for Oracle or Microsoft SQL Server, you must specify this option when copying across Amazon Web Services Regions. For more information, see Option group considerations in the Amazon RDS User Guide.
pre_signed_url
instance-attribute
¶
pre_signed_url: str | None
When you are copying a snapshot from one Amazon Web Services GovCloud
(US) Region to another, the URL that contains a Signature Version 4
signed request for the CopyDBSnapshot API operation in the source
Amazon Web Services Region that contains the source DB snapshot to copy.
This setting applies only to Amazon Web Services GovCloud (US) Regions. It's ignored in other Amazon Web Services Regions.
You must specify this parameter when you copy an encrypted DB snapshot
from another Amazon Web Services Region by using the Amazon RDS API.
Don't specify PreSignedUrl when you are copying an encrypted DB
snapshot in the same Amazon Web Services Region.
The presigned URL must be a valid request for the
CopyDBClusterSnapshot API operation that can run in the source Amazon
Web Services Region that contains the encrypted DB cluster snapshot to
copy. The presigned URL request must contain the following parameter
values:
DestinationRegion- The Amazon Web Services Region that the encrypted DB snapshot is copied to. This Amazon Web Services Region is the same one where theCopyDBSnapshotoperation is called that contains this presigned URL.
For example, if you copy an encrypted DB snapshot from the us-west-2
Amazon Web Services Region to the us-east-1 Amazon Web Services
Region, then you call the CopyDBSnapshot operation in the us-east-1
Amazon Web Services Region and provide a presigned URL that contains a
call to the CopyDBSnapshot operation in the us-west-2 Amazon Web
Services Region. For this example, the DestinationRegion in the
presigned URL must be set to the us-east-1 Amazon Web Services Region.
-
KmsKeyId- The KMS key identifier for the KMS key to use to encrypt the copy of the DB snapshot in the destination Amazon Web Services Region. This is the same identifier for both theCopyDBSnapshotoperation that is called in the destination Amazon Web Services Region, and the operation contained in the presigned URL. -
SourceDBSnapshotIdentifier- The DB snapshot identifier for the encrypted snapshot to be copied. This identifier must be in the Amazon Resource Name (ARN) format for the source Amazon Web Services Region. For example, if you are copying an encrypted DB snapshot from the us-west-2 Amazon Web Services Region, then yourSourceDBSnapshotIdentifierlooks like the following example:arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20161115.
To learn how to generate a Signature Version 4 signed request, see Authenticating Requests: Using Query Parameters (Amazon Web Services Signature Version 4) and Signature Version 4 Signing Process.
Note
If you are using an Amazon Web Services SDK tool or the CLI, you can
specify SourceRegion (or --source-region for the CLI) instead of
specifying PreSignedUrl manually. Specifying SourceRegion
autogenerates a presigned URL that is a valid request for the operation
that can run in the source Amazon Web Services Region.
snapshot_availability_zone
instance-attribute
¶
snapshot_availability_zone: str | None
Specifies the name of the Availability Zone where RDS stores the DB snapshot. This value is valid only for snapshots that RDS stores on a Dedicated Local Zone.
snapshot_target
instance-attribute
¶
snapshot_target: str | None
Configures the location where RDS will store copied snapshots.
Valid Values:
-
local(Dedicated Local Zone) -
outposts(Amazon Web Services Outposts) -
region(Amazon Web Services Region)
source_db_snapshot_identifier
instance-attribute
¶
The identifier for the source DB snapshot.
If the source snapshot is in the same Amazon Web Services Region as the
copy, specify a valid DB snapshot identifier. For example, you might
specify rds:mysql-instance1-snapshot-20130805.
If you are copying from a shared manual DB snapshot, this parameter must be the Amazon Resource Name (ARN) of the shared DB snapshot.
If the source snapshot is in a different Amazon Web Services Region than
the copy, specify a valid DB snapshot ARN. You can also specify an ARN
of a snapshot that is in a different account and a different Amazon Web
Services Region. For example, you might specify
arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20130805.
Constraints:
- Must specify a valid source snapshot in the "available" state.
Example: rds:mydb-2012-04-02-00-01
Example:
arn:aws:rds:us-west-2:123456789012:snapshot:mysql-instance1-snapshot-20130805
tag_specifications
instance-attribute
¶
tag_specifications: Sequence[TagSpecification | TagSpecificationDict] | None
Tags to assign to the copied option group. By default, the copied option group isn't tagged.
Valid Values:
og- The copied option group.
Constraints:
- Can only be specified when
CopyOptionGroupistrue
tags
instance-attribute
¶
A list of tags.
For more information, see Tagging Amazon RDS resources in the Amazon RDS User Guide or Tagging Amazon Aurora and Amazon RDS resources in the Amazon Aurora User Guide.
target_custom_availability_zone
instance-attribute
¶
target_custom_availability_zone: str | None
The external custom Availability Zone (CAZ) identifier for the target CAZ.
Example: rds-caz-aiqhTgQv.
target_db_snapshot_identifier
instance-attribute
¶
The identifier for the copy of the snapshot.
Constraints:
-
Can't be null, empty, or blank
-
Must contain from 1 to 255 letters, numbers, or hyphens
-
First character must be a letter
-
Can't end with a hyphen or contain two consecutive hyphens
Example: my-db-snapshot
Output¶
CopyDBSnapshotOutput
dataclass
¶
Bases: _SerdeShape
Dataclass for CopyDBSnapshotOutput structure.
Attributes¶
db_snapshot
class-attribute
instance-attribute
¶
db_snapshot: DBSnapshot | None = ...
Contains the details of an Amazon RDS DB snapshot.
This data type is used as a response element in the
DescribeDBSnapshots action.
response_metadata
class-attribute
instance-attribute
¶
Metadata about the response that produced this output. Use this to recover the request identifiers a service's support team needs in order to investigate a call. Members of the metadata are individually optional.